`timescale	1ps / 1ps
////////////////////////////////////////////////////////////////////////////////
//
// Filename:	./main.v
//
// Project:	Verilog Tutorial Example file
//
// DO NOT EDIT THIS FILE!
// Computer Generated: This file is computer generated by AUTOFPGA. DO NOT EDIT.
// DO NOT EDIT THIS FILE!
//
// CmdLine:	/home/dan/work/rnd/opencores/autofpga/trunk/sw/autofpga /home/dan/work/rnd/opencores/autofpga/trunk/sw/autofpga -d autofpga.dbg global.txt clock.txt hexbus.txt simhalt.txt version.txt tonegen.txt
//
// Creator:	Dan Gisselquist, Ph.D.
//		Gisselquist Technology, LLC
//
////////////////////////////////////////////////////////////////////////////////
//
// Written and distributed by Gisselquist Technology, LLC
//
// This program is hereby granted to the public domain.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY or
// FITNESS FOR A PARTICULAR PURPOSE.
//
////////////////////////////////////////////////////////////////////////////////
//
//
`default_nettype	none
//
//
// Here is a list of defines which may be used, post auto-design
// (not post-build), to turn particular peripherals (and bus masters)
// on and off.  In particular, to turn off support for a particular
// design component, just comment out its respective `define below.
//
// These lines are taken from the respective @ACCESS tags for each of our
// components.  If a component doesn't have an @ACCESS tag, it will not
// be listed here.
//
// First, the independent access fields for any bus masters
// And then for the independent peripherals
//
// End of dependency list
//
//
//
// Any include files
//
// These are drawn from anything with a MAIN.INCLUDE definition.
//
//
// Finally, we define our main module itself.  We start with the list of
// I/O ports, or wires, passed into (or out of) the main function.
//
// These fields are copied verbatim from the respective I/O port lists,
// from the fields given by @MAIN.PORTLIST
//
module	main(i_clk, i_reset,
		// Tone generator outputs
		o_audio_ce, o_sample, o_audio,
 		// UART/host to wishbone interface
 		i_host_uart_rx, o_host_uart_tx,
		o_simhalt);
//
// Any parameter definitions
//
// These are drawn from anything with a MAIN.PARAM definition.
// As they aren't connected to the toplevel at all, it would
// be best to use localparam over parameter, but here we don't
// check
//
// The next step is to declare all of the various ports that were just
// listed above.  
//
// The following declarations are taken from the values of the various
// @MAIN.IODECL keys.
//
	input	wire		i_clk;
	// verilator lint_off UNUSED
	input	wire		i_reset;
	// verilator lint_on UNUSED
	// Define our tone generator's outputs
	output	wire		o_audio_ce;
	output	wire	[15:0]	o_sample;
	output	wire		o_audio;
	input	wire		i_host_uart_rx;
	output	wire		o_host_uart_tx;
	output	reg	o_simhalt;
	// Make Verilator happy ... defining bus wires for lots of components
	// often ends up with unused wires lying around.  We'll turn off
	// Ver1lator's lint warning here that checks for unused wires.
	// verilator lint_off UNUSED



	//
	// Declaring interrupt lines
	//
	// These declarations come from the various components values
	// given under the @INT.<interrupt name>.WIRE key.
	//


	//
	// Component declarations
	//
	// These declarations come from the @MAIN.DEFNS keys found in the
	// various components comprising the design.
	//
	//
	//
	// UART interface
	//
	//
	localparam [23:0] BUSUART = 24'h64;	// 1000000 baud
	//
	wire	w_ck_uart, w_uart_tx;
	wire		rx_host_stb;
	wire	[7:0]	rx_host_data;
	wire		tx_host_stb;
	wire	[7:0]	tx_host_data;
	wire		tx_host_busy;
`include "builddate.v"


	//
	// Declaring interrupt vector wires
	//
	// These declarations come from the various components having
	// PIC and PIC.MAX keys.
	//
	//
	//
	// Define bus wires
	//
	//

	// Bus wb
	// Wishbone definitions for bus wb, component hb
	// Verilator lint_off UNUSED
	wire		wb_hb_cyc, wb_hb_stb, wb_hb_we;
	wire	[9:0]	wb_hb_addr;
	wire	[31:0]	wb_hb_data;
	wire	[3:0]	wb_hb_sel;
	wire		wb_hb_stall, wb_hb_ack, wb_hb_err;
	wire	[31:0]	wb_hb_idata;
	// Verilator lint_on UNUSED
	// Wishbone definitions for bus wb, component simhalt
	// Verilator lint_off UNUSED
	wire		wb_simhalt_cyc, wb_simhalt_stb, wb_simhalt_we;
	wire	[9:0]	wb_simhalt_addr;
	wire	[31:0]	wb_simhalt_data;
	wire	[3:0]	wb_simhalt_sel;
	wire		wb_simhalt_stall, wb_simhalt_ack, wb_simhalt_err;
	wire	[31:0]	wb_simhalt_idata;
	// Verilator lint_on UNUSED
	// Wishbone definitions for bus wb, component version
	// Verilator lint_off UNUSED
	wire		wb_version_cyc, wb_version_stb, wb_version_we;
	wire	[9:0]	wb_version_addr;
	wire	[31:0]	wb_version_data;
	wire	[3:0]	wb_version_sel;
	wire		wb_version_stall, wb_version_ack, wb_version_err;
	wire	[31:0]	wb_version_idata;
	// Verilator lint_on UNUSED
	// Wishbone definitions for bus wb, component tonegen
	// Verilator lint_off UNUSED
	wire		wb_tonegen_cyc, wb_tonegen_stb, wb_tonegen_we;
	wire	[9:0]	wb_tonegen_addr;
	wire	[31:0]	wb_tonegen_data;
	wire	[3:0]	wb_tonegen_sel;
	wire		wb_tonegen_stall, wb_tonegen_ack, wb_tonegen_err;
	wire	[31:0]	wb_tonegen_idata;
	// Verilator lint_on UNUSED

	//
	// Peripheral address decoding
	//
	//
	// BUS-LOGIC for wb
	//
	//
	// No class SINGLE peripherals on the "wb" bus
	//

	//
	// No class DOUBLE peripherals on the "wb" bus
	//

	assign	wb_simhalt_err= 1'b0;
	assign	wb_version_err= 1'b0;
	assign	wb_tonegen_err= 1'b0;
	//
	// Connect the wb bus components together using the wbxbar()
	//
	//
	wbxbar #(
		.NM(1), .NS(3), .AW(10), .DW(32),
		.SLAVE_ADDR({
			// Address width    = 10
			// Address LSBs     = 2
			// Slave name width = 7
			{ 10'h300 }, // tonegen: 0xc00
			{ 10'h200 }, // version: 0x800
			{ 10'h100 }  // simhalt: 0x400
		}),
		.SLAVE_MASK({
			// Address width    = 10
			// Address LSBs     = 2
			// Slave name width = 7
			{ 10'h300 }, // tonegen
			{ 10'h300 }, // version
			{ 10'h300 }  // simhalt
		}),
		.OPT_DBLBUFFER(1'b1))
	wb_xbar(
		.i_clk(i_clk), .i_reset(i_reset),
		.i_mcyc({
			wb_hb_cyc
		}),
		.i_mstb({
			wb_hb_stb
		}),
		.i_mwe({
			wb_hb_we
		}),
		.i_maddr({
			wb_hb_addr
		}),
		.i_mdata({
			wb_hb_data
		}),
		.i_msel({
			wb_hb_sel
		}),
		.o_mstall({
			wb_hb_stall
		}),
		.o_mack({
			wb_hb_ack
		}),
		.o_mdata({
			wb_hb_idata
		}),
		.o_merr({
			wb_hb_err
		}),
		// Slave connections
		.o_scyc({
			wb_tonegen_cyc,
			wb_version_cyc,
			wb_simhalt_cyc
		}),
		.o_sstb({
			wb_tonegen_stb,
			wb_version_stb,
			wb_simhalt_stb
		}),
		.o_swe({
			wb_tonegen_we,
			wb_version_we,
			wb_simhalt_we
		}),
		.o_saddr({
			wb_tonegen_addr,
			wb_version_addr,
			wb_simhalt_addr
		}),
		.o_sdata({
			wb_tonegen_data,
			wb_version_data,
			wb_simhalt_data
		}),
		.o_ssel({
			wb_tonegen_sel,
			wb_version_sel,
			wb_simhalt_sel
		}),
		.i_sstall({
			wb_tonegen_stall,
			wb_version_stall,
			wb_simhalt_stall
		}),
		.i_sack({
			wb_tonegen_ack,
			wb_version_ack,
			wb_simhalt_ack
		}),
		.i_sdata({
			wb_tonegen_idata,
			wb_version_idata,
			wb_simhalt_idata
		}),
		.i_serr({
			wb_tonegen_err,
			wb_version_err,
			wb_simhalt_err
		})
		);

	//
	// Declare the interrupt busses
	//
	// Interrupt busses are defined by anything with a @PIC tag.
	// The @PIC.BUS tag defines the name of the wire bus below,
	// while the @PIC.MAX tag determines the size of the bus width.
	//
	// For your peripheral to be assigned to this bus, it must have an
	// @INT.NAME.WIRE= tag to define the wire name of the interrupt line,
	// and an @INT.NAME.PIC= tag matching the @PIC.BUS tag of the bus
	// your interrupt will be assigned to.  If an @INT.NAME.ID tag also
	// exists, then your interrupt will be assigned to the position given
	// by the ID# in that tag.
	//


	//
	//
	// Now we turn to defining all of the parts and pieces of what
	// each of the various peripherals does, and what logic it needs.
	//
	// This information comes from the @MAIN.INSERT and @MAIN.ALT tags.
	// If an @ACCESS tag is available, an ifdef is created to handle
	// having the access and not.  If the @ACCESS tag is `defined above
	// then the @MAIN.INSERT code is executed.  If not, the @MAIN.ALT
	// code is exeucted, together with any other cleanup settings that
	// might need to take place--such as returning zeros to the bus,
	// or making sure all of the various interrupt wires are set to
	// zero if the component is not included.
	//
	tonegen #(.CLOCK_RATE_HZ(100000000))
	tonegeni(i_clk, i_reset,
		wb_tonegen_cyc, wb_tonegen_stb, wb_tonegen_we,
			wb_tonegen_addr[2-1:0],
			wb_tonegen_data, // 32 bits wide
			wb_tonegen_sel,  // 32/8 bits wide
		wb_tonegen_stall, wb_tonegen_ack, wb_tonegen_idata,
		// Connect our outgoing signals
		o_audio_ce, o_sample, o_audio);
	// The Host USB interface, to be used by the WB-UART bus
	rxuartlite	#(BUSUART) rcv(i_clk, i_host_uart_rx,
				rx_host_stb, rx_host_data);
	txuartlite	#(BUSUART) txv(i_clk, tx_host_stb, tx_host_data,
				o_host_uart_tx, tx_host_busy);

`ifndef	BUSPIC_ACCESS
	wire	w_bus_int;
	assign	w_bus_int = 1'b0;
`endif

	//
	// The debugging bus--translating UART inputs into bus commands
	// and returning responses over the UART
	//
	hbbus	#(.AW(10)) genbus(i_clk,
			rx_host_stb, rx_host_data,
			wb_hb_cyc, wb_hb_stb, wb_hb_we,
			wb_hb_addr[10-1:0],
			wb_hb_data, // 32 bits wide
			wb_hb_sel,  // 32/8 bits wide
		wb_hb_stall, wb_hb_ack, wb_hb_idata,wb_hb_err,
			w_bus_int,
			tx_host_stb, tx_host_data, tx_host_busy);

	//
	// A simulation only peripheral: SIMHALT.  Sets a one-bit flag,
	// o_simhalt, read by the simulator as an indication of when to
	// halt the simulation.  Makes it easy to halt the simulation from
	// within the simulator.
	//
	initial	o_simhalt=1'b0;
	always @(posedge i_clk)
	if (wb_simhalt_stb && wb_simhalt_we)
		o_simhalt <= wb_simhalt_data[0];

	assign	wb_simhalt_idata = 32'h0;
	assign	wb_simhalt_ack   = wb_simhalt_stb;
	assign	wb_simhalt_stall = 1'b0;
	assign	wb_version_idata = `DATESTAMP;
	assign	wb_version_ack   = wb_version_stb;
	assign	wb_version_stall = 1'b0;


endmodule // main.v
